<?php
// script to convert a csv-like file to latex code

$latex = '\documentclass[10pt,a4paper]{article}'."\n"
	  .'\usepackage[a4paper, left=2cm, right=2cm, top=2cm, bottom=2cm,landscape]{geometry}'."\n"
	  .'\usepackage{amsmath}'."\n"
	  .'\usepackage{amsfonts}'."\n"
	  .'\usepackage{amssymb}'."\n"
	  .'\usepackage{array}'."\n"
	  .'\usepackage{longtable}'."\n"
	  .'\usepackage{textcomp}'."\n"
	  .'\author{IWR}'."\n"
	  .'\parindent0cm'."\n"
	  .'\parsep.5ex'."\n"
	  .'\newcommand{\basis}{{(name)->}}'."\n"
	  .'\begin{document}'."\n";

$filesToRead = array();
$dir = './parameters';
if ($handle = opendir($dir)) {
  while (false !== ($file = readdir($handle))) {
    if ($file != "." && $file != ".." && preg_match('/\.inc$/',$file)>0) {
      $filesToRead[] = $dir.'/'.$file;
    }
  }
  closedir($handle);
}
sort($filesToRead, SORT_STRING);

foreach($filesToRead as $file) {
$row = 1;
if (($handle = fopen($file, "r")) !== FALSE) {
    $writeData = false;
    if (($data = fgetcsv($handle, 1000, "|")) !== FALSE) {
      if (strlen(trim($data[0]))>0)
	$latex .= '\section{'.$data[0].'}'."\n";
      $latex .= $data[1]."\n";
      $latex .= '{'."\n";
	$latex .= '\small'."\n";
	if (count($data)>2)
	  $latex .= $data[2]."\n";
	$latex .= '\begin{longtable}[l]{|>{\ttfamily}lp{.15\textwidth}>{\ttfamily}lp{.4\textwidth}|}'."\n"
		  .'\hline'."\n"
		  .'\textrm{\textbf{keyword}} & \textrm{\textbf{data type}} & \textrm{\textbf{default}} & \textrm{\textbf{description}} \\\\'."\n"
		  .'\hline\hline'."\n\n".'\hline';
	$writeData = true;
    }
    if ($writeData) {
      while (($data = fgetcsv($handle, 1000, "|")) !== FALSE) {
	$latex .= '\basis '.$data[0].' & \textbf{'.$data[1].'} & ['.$data[2].'] & '.$data[3].'\\\\ \hline'."\n";
      }
      $latex .= '\end{longtable}'."\n".'}'."\n\n";
    }
    fclose($handle);
}
}

$latex .= '\end{document}';

if (($handle = fopen('parameters.tex', "w")) !== FALSE) {
  fwrite($handle, $latex);
}
?>